library libenrupt;

{$Q-}
{$R-}

(*************************************************************************

Ruptor's Enrupt cipher pascal port

(c) 2008 Alexander Myasnikow

Web: www.darksoftware.narod.ru 


**************************************************************************)


type
  longwordarray = array [0..15] of longword;
type
  plongwordarray = ^longwordarray;

  function lrotr (N: longword): longword;
  asm
    MOV EAX, N
    ROR EAX, 8

  end;


  function rupt (x0, x2, k, r: longword): longword;
  begin
    Result := longword(lrotr(longword(2 * x0 xor x2 xor k xor r)) * 9);
  end;

  procedure rupt1 (x0: longword; var x1: longword; x2, k, r: longword);
  begin
    x1 := x1 xor (rupt(x0, x2, k, r) xor k);
  end;

  function enRUPT (x, k: plongwordarray; xw, kw: longword): integer;
  var
    r: longword;
  begin

    for r := 1 to 8 * (xw) + 4 * kw do
      begin

      rupt1(x[(r - 1) mod (xw)], x[r mod (xw)], x[(r + 1) mod (xw)], k[r mod (kw)], r);

      end;
    Result := 0;
  end;


  function unRUPT (x, k: plongwordarray; xw, kw: longword): integer;
  var
    r: longword;
  begin

    for r := 8 * (xw) + 4 * (kw) downto 1 do
      begin

      rupt1(x[(r - 1) mod (xw)], x[r mod (xw)], x[(r + 1) mod (xw)], k[r mod (kw)], r);

      end;


    Result := 0;
  end;


  procedure crypt (x, k: plongwordarray); export; stdcall;
  begin
    enRupt(x, k, 16, 16);
  end;

  procedure decrypt (x, k: plongwordarray); export; stdcall;
  begin
    unRupt(x, k, 16, 16);
  end;


exports
  crypt,
  decrypt;

end.
